This service will be undergoing maintenance at 00:00 UTC, 2016-09-28. It is expected to last about 1 hours
Bug 791180 - Bugs found in anaconda-17.8-1.fc17 using gcc-with-cpychecker static analyzer
Bugs found in anaconda-17.8-1.fc17 using gcc-with-cpychecker static analyzer
Status: CLOSED CURRENTRELEASE
Product: Fedora
Classification: Fedora
Component: anaconda (Show other bugs)
19
Unspecified Unspecified
unspecified Severity unspecified
: ---
: ---
Assigned To: Chris Lumens
Fedora Extras Quality Assurance
http://fedorapeople.org/~dmalcolm/gcc...
:
Depends On:
Blocks: cpychecker
  Show dependency treegraph
 
Reported: 2012-02-16 07:17 EST by Dave Malcolm
Modified: 2013-04-15 09:24 EDT (History)
3 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2013-04-15 09:24:40 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:


Attachments (Terms of Use)

  None (edit)
Description Dave Malcolm 2012-02-16 07:17:59 EST
Description of problem:
I've been writing an experimental static analysis tool to detect bugs commonly occurring within C Python extension modules:
  https://fedorahosted.org/gcc-python-plugin/
  http://gcc-python-plugin.readthedocs.org/en/latest/cpychecker.html
  http://fedoraproject.org/wiki/Features/StaticAnalysisOfPythonRefcounts

I ran the latest version of the tool (in git master; post 0.9) on
anaconda-17.8-1.fc17.src.rpm, and it reports various errors.

You can see a list of errors here, triaged into categories (from most significant to least significant):
http://fedorapeople.org/~dmalcolm/gcc-python-plugin/2012-02-16/anaconda-17.8-1.fc17/

I visually inspected the bug reports there, and some seem like genuine (albeit minor) issues:

"Reference count too low":
 isys.c:doWipeRaidSuperblock:ob_refcnt of return value is 1 too low
   this should use "Py_RETURN_NONE;" rather than "return Py_None;"


"Reference leaks"
 isys.c:doMount:ob_refcnt of '*tuple' is 1 too high
 isys.c:doUMount:ob_refcnt of '*tuple' is 1 too high
   In both cases, the path that raises SystemError leaks the tuple of extra information



"Reference leak within initialization"
 isys.c:init_isys:ob_refcnt of PyIntObject is 1 too high
   Minor leak

"Segfaults within error-handling paths"
  Various places where the code doesn't check for NULL

"Returning (PyObject*)NULL without setting an exception"
 isys.c:doPrefixToNetmask:returning (PyObject*)NULL without setting an exception
   This one looks like a genuine bug: what sets the exception on this "return NULL" path?

There may of course be other bugs in my checker tool.

Hope this is helpful; let me know if you need help reading the logs that the tool generates - I know that it could use some improvement.

Version-Release number of selected component (if applicable):
anaconda-17.8-1.fc17
gcc-python-plugin post-0.9 git 073d390de53ef52136bd90e5ac06f1ef833d047d running the checker in an *f16* chroot
Comment 1 Fedora End Of Life 2013-04-03 09:38:43 EDT
This bug appears to have been reported against 'rawhide' during the Fedora 19 development cycle.
Changing version to '19'.

(As we did not run this process for some time, it could affect also pre-Fedora 19 development
cycle bugs. We are very sorry. It will help us with cleanup during Fedora 19 End Of Life. Thank you.)

More information and reason for this action is here:
https://fedoraproject.org/wiki/BugZappers/HouseKeeping/Fedora19
Comment 2 Chris Lumens 2013-04-15 09:21:54 EDT
We've been on an isys removal kick since F17, which has reduced the set of problems to just the ones in init_isys.  I'll take a look.
Comment 3 Chris Lumens 2013-04-15 09:24:40 EDT
I should have been more thorough in my investigation first.  init_isys has been reduced to a single line, too.  Feel free to re-run your checks against F19 if you would like.

Note You need to log in before you can comment on or make changes to this bug.